<?php
include '../comunes_php/cors.php';
 
    $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
    $parametros = print_r($_POST,TRUE);
    fwrite($myfile, "\n");
    fwrite($myfile, "---------------------------". date("Y-m-d H:i:s") ."--------------------------------------------------------");
    fwrite($myfile, "\n");    
    fwrite($myfile, "----------------------------nuevo registro log-------------------------------------------------------");
    fwrite($myfile, "\n");    
    fwrite($myfile, "-----------------------------------------------------------------------------------------------------");
    
    fwrite($myfile, "\n");
    
    fwrite($myfile, $parametros);
    fclose($myfile);

    $page = isset($_POST['page']) ? intval($_POST['page']) : 1;
    $rows = isset($_POST['rows']) ? intval($_POST['rows']) : 10;
    $offset = ($page-1)*$rows;
    $result = array();
    $mensaje = "Fueron guardados sus datos";
    include '../rdb/conn.php';





    $id = $_POST['id'];
    $usuario_id =$_REQUEST['usuario_id'];
    
	$dpfechaAlta=    isset($_REQUEST['dpfechaAlta']) ? (is_null($_REQUEST['dpfechaAlta'])? NULL:$_REQUEST['dpfechaAlta']) : NULL;
	$dpfechaAprobado=    isset($_REQUEST['dpfechaAprobado']) ?(is_null($_REQUEST['dpfechaAprobado'])? NULL:$_REQUEST['dpfechaAprobado']) : NULL;
	$cmbEmpresa= isset($_REQUEST['cmbempresa']) ?(is_null($_REQUEST['cmbempresa'])?  '-1':$_REQUEST['cmbempresa']) : '-1';

	$cmbCliente= isset($_REQUEST['cmbCliente']) ?(is_null($_REQUEST['cmbCliente'])?  '-1':$_REQUEST['cmbCliente']) : '-1';
	$cmbTipoEnvio= isset($_REQUEST['cmbTipoEnvio']) ?(is_null($_REQUEST['cmbTipoEnvio'])?  '-1':$_REQUEST['cmbTipoEnvio']) : '-1';
	
	$cmbVendedor= isset($_REQUEST['cmbVendedor']) ? $_REQUEST['cmbVendedor'] : '-1';
	$cmbRepartidor= isset($_REQUEST['cmbRepartidor']) ? $_REQUEST['cmbRepartidor'] : '-1';
	$comentarios= isset($_REQUEST['txtComentarios']) ? $_REQUEST['txtComentarios'] : '';


	$txtTelefono1= isset($_REQUEST['txtTelefono1']) ? $_REQUEST['txtTelefono1'] : '';
	$txtTelefono2= isset($_REQUEST['txtTelefono2']) ? $_REQUEST['txtTelefono2'] : '';
	$mail_cliente= isset($_REQUEST['mail_cliente']) ? $_REQUEST['mail_cliente'] : '';

	$cmbHoraEnSemana = isset($_REQUEST['cmbHoraEnSemana']) ? $_REQUEST['cmbHoraEnSemana'] : '-1';
	$cmbHoraEnSabado = isset($_REQUEST['cmbHoraEnSabado']) ? $_REQUEST['cmbHoraEnSabado'] : '-1';
	
	$txtDemora= isset($_REQUEST['txtDemora']) ? $_REQUEST['txtDemora'] : '';
	$txtContactoEntrega= isset($_REQUEST['txtContactoEntrega']) ? $_REQUEST['txtContactoEntrega'] : '';
	$aliasml= isset($_REQUEST['alias_ml']) ? $_REQUEST['alias_ml'] : '';


	$txtDireccionEntrega= isset($_REQUEST['txtDireccionEntrega']) ? $_REQUEST['txtDireccionEntrega'] : '';

	$cmbZona = isset($_REQUEST['cmbZona']) ? $_REQUEST['cmbZona'] : '-1';

	$txtFlete= isset($_REQUEST['txtFlete']) ? $_REQUEST['txtFlete'] : '';

	$Tarjeta= isset($_REQUEST['sbTarjeta']) ? $_REQUEST['sbTarjeta'] : '';

	$subtotal= isset($_REQUEST['subtotal']) ? $_REQUEST['subtotal'] : '0';
	$recargoEnvio= isset($_REQUEST['recargoEnvio']) ? $_REQUEST['recargoEnvio'] : '0';
	$recargoArmado= isset($_REQUEST['recargoArmado']) ? $_REQUEST['recargoArmado'] : '0';
	$recargoEscalera= isset($_REQUEST['recargoEscalera']) ? $_REQUEST['recargoEscalera'] : '0';


	$total= isset($_REQUEST['total']) ? $_REQUEST['total'] : '0';


	
    
    $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
    $parametros = print_r($_POST,TRUE);
    fwrite($myfile, "\n");
    fwrite($myfile, "---------------------------". date("Y-m-d H:i:s") ."--------------------------------------------------------");
    fwrite($myfile, "\n");    
    fwrite($myfile, "----------------------------nuevo registro log-------------------------------------------------------");
    fwrite($myfile, "\n");    
    fwrite($myfile, "-----------------------------------------------------------------------------------------------------");
    
    fwrite($myfile, "\n");
    
    fwrite($myfile, $parametros);
    fclose($myfile);

	    
//    $fecha_actual= date("Y-m-d H:i:s");
//    $fecha_actual= $_POST['fecha'];
 
  
  
try {    
mysqli_query( $conn,"SET AUTOCOMMIT=0");
mysqli_query( $conn,"START TRANSACTION");


    if (isset($_POST['id']) && trim($_POST['id'])!='ALTA') {
        //modificacion
         
$sql=" UPDATE `contratos_cabecera` SET ";
	if ($cmbCliente<>'') {$sql .="`cliente_id`= $cmbCliente,     "; }
	if ($cmbTipoEnvio<>'') {$sql .="`tipo_envio_id`= $cmbTipoEnvio,     "; }
	if ($cmbRepartidor<>'') {$sql .="`repartidor_id`= $cmbRepartidor,     "; }
	if ($cmbVendedor<>'') {$sql .="`vendedor_id`= $cmbVendedor,     "; }
	if ($txtTelefono1<>'') {$sql .="`telefono_1`='$txtTelefono1',     "; }
	if ($txtTelefono2<>'') {$sql .="`telefono_2`='$txtTelefono2',     "; }
	if ($cmbHoraEnSemana<>'') {$sql .="`horarios_en_semana`= $cmbHoraEnSemana,     "; }
	if ($cmbHoraEnSabado<>'') {$sql .="`horarios_en_sabado`= $cmbHoraEnSabado,     "; }
	if ($txtDireccionEntrega<>'') {$sql .="`direccion`='$txtDireccionEntrega',     "; }
	if ($txtContactoEntrega<>'') {$sql .="`contacto`='$txtContactoEntrega',     "; }
    if ($comentarios<>'') {$sql .="`comentarios`='$comentarios',     "; }
    
    if ($mail_cliente<>'') {$sql .=" email='$mail_cliente',     "; }
    
	
	if ($aliasml<>'') {$sql .="`alias_ml`='$aliasml',     "; }
	if ($txtDemora<>'') {$sql .="`demora`='$txtDemora',     "; }

	if ($cmbZona<>'') {$sql .="`zona_id`= $cmbZona,     "; }
	

	if ($subtotal<>'') {$sql .="`subtotal`=$subtotal,     "; }
	if ($Tarjeta<>'') {$sql .="`tarjeta`='$Tarjeta',     "; }
	if ($recargoEnvio<>'') {$sql .="`envio`=$recargoEnvio,     "; }
	if ($recargoArmado<>'') {$sql .="`armado`=$recargoArmado,     "; }
	
	if ($recargoEscalera<>'') {$sql .="`escalera`=$recargoEscalera,     "; }
	if ($total<>'0') {$sql .="`total`=$total,     "; }
	if ($cmbEmpresa<>'') {$sql .="`empresa_id`= $cmbEmpresa,     "; }
	


    $sql.="`borrado`=0 ";

    $sql.=" WHERE id=$id";
								     

	
      		    $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
      		    fwrite($myfile, "\n");  
      		    fwrite($myfile, date("Y-m-d H:i:s")."*****************MODIFICACION*****************");
		        fwrite($myfile, "\n");      		    
        	    fwrite($myfile, $sql);
        	    fwrite($myfile, "\n");
        	    fclose($myfile);	

            $visitante ="Acceso desde IP: " .$_SERVER['REMOTE_ADDR'] ;
            $fecha= date("Y-m-d H:i:s");
            $accion = $sql;

            $valor="";
            $sqlv  = "INSERT INTO visitas ( fecha, visitante, accion) VALUES ";
            $sqlv .= " ('$fecha','$visitante','$accion')";
            @mysqli_query( $conn,$sqlv);

            @mysqli_query( $conn,$sql);
            $actualizados=mysqli_affected_rows($conn);

            $result["sql"]=$sql;
            
            //si vienen armo un arreglo con el contenido y doy de alta
            
             if (isset($_POST['renglones'])){
                $renglones= json_decode($_POST['renglones'], true);
                
                $sql = "delete from  contrato_detalle_adicionales where contrato_id=$id";
                @mysqli_query( $conn,$sql);
                $sql = "delete from  contratos_detalle where contrato_id=$id";
                @mysqli_query( $conn,$sql);

                $orden=0;
                 foreach($renglones as $cr){
                     //primero meto los renglones de los productos 
                    $orden++;
                    if (empty($cr[_parentId])) {
					    list($renglon_id, $producto_id) = explode(".", $cr[id]);
                        //busco la fabrica del producto que se esta insertando
                        $sql= " select fabrica_id from productos_por_fabrica where  producto_id=$producto_id ";
                        $rs = mysqli_query( $conn,$sql);
                        $row = mysqli_fetch_row($rs);
                        $fabrica_id = $row[0];
                           
    					if ($Tarjeta=='on'){
                            $precio_producto=  $cr[precio_tarjeta];
                        }
                        else
                        {
                            $precio_producto= $cr[preciounitario];
                        }
                        
                        $sql  ="INSERT INTO `contratos_detalle`";
                        $sql  .="(`contrato_id`, `renglon_id`, `producto_id`, ";
                        $sql  .="`fabrica_id`, `fecha_fin`, `precio`,";
                        $sql  .="`borrado`) VALUES ";
                        $sql  .="($id,$renglon_id,$producto_id,";
                        $sql  .="$fabrica_id,now(),$precio_producto,";
                        $sql  .="0)"; 
					    @mysqli_query( $conn,$sql);
                        //guardo en log el sql realizado para el producto
               		    $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
              		    fwrite($myfile, "\n");
        
                	    fwrite($myfile, $sql);
        		        fwrite($myfile, "\n");        	    
                	    fclose($myfile);					    

					} 

                }
                 foreach($renglones as $cr){
                    $orden++;
                    if (!empty($cr[_parentId]))  
                    {
                        //luego que todos los renglones de los productos estan metidos meto los adicionales
						list($renglon_id, $producto_id, $adicional_id) = explode(".", $cr[id]);
    
                        $sql= " select fabrica_id from productos_por_fabrica where  producto_id=$producto_id ";
                        $rs = mysqli_query( $conn,$sql);
                        $row = mysqli_fetch_row($rs);
                        $fabrica_id = $row[0];
                           
    					
                        $sql  ="INSERT INTO `contrato_detalle_adicionales`";
                        $sql  .="(`contrato_id`, `renglon_id`, `producto_id`, ";
                        $sql  .="`adicional_id`, `precio`,  ";
                        $sql  .="`borrado`) VALUES ";
                        $sql  .="($id,$renglon_id,$producto_id,";
                        $sql  .="$adicional_id,$cr[preciounitario],";
                        $sql  .="0)"; 
	                    @mysqli_query( $conn,$sql);

						//guardo en log el sql realizado para el detalle
 
				        $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
              		    fwrite($myfile, "\n");
                	    fwrite($myfile, $sql);
        		        fwrite($myfile, "\n");        	    
                	    fclose($myfile);		 
						 
					}
                }          


            } //fin de area de manejo de renglones



            $visitante ="Acceso desde IP: " .$_SERVER['REMOTE_ADDR'] ;
            $fecha= date("Y-m-d H:i:s");
            $accion = $sql;
            $valor="";
            $sql  = "INSERT INTO visitas ( fecha, visitante, accion) VALUES ";
            $sql .= " ('$fecha','$visitante','$accion')";
            @mysqli_query( $conn,$sql);
    } // fin modificaciones 
    else
    {
        //alta        
    	   $sql= " select IFNULL(max(id),0)+1 from contratos_cabecera ";
    
    	    $rs = mysqli_query( $conn,$sql);
    	    $row = mysqli_fetch_row($rs);
    	    $id = $row[0];
    

	
	
            $sql  ="INSERT INTO ";
            $sql  .="	`contratos_cabecera`";
            $sql  .="	(`id`, `cliente_id`, `estado_id`, ";
            $sql  .="	`repartidor_id`, `tipo_envio_id`, `borrado`, ";
            $sql  .="	`vendedor_id`, `telefono_1`, `telefono_2`, ";
            $sql  .="	`horarios_en_semana`, `horarios_en_sabado`, `direccion`, ";
            $sql  .="	`zona_id`, `contacto`, `demora`, ";
            $sql  .="	`subtotal`, `tarjeta`, `envio`,`armado`, ";
            $sql  .="	`escalera`, `total`,comentarios,email,alias_ml,empresa_id) VALUES";
            $sql  .="   ($id,$cmbCliente,1,";
            $sql  .="   $cmbRepartidor,$cmbTipoEnvio,0,";
            $sql  .="	$cmbVendedor,'$txtTelefono1','$txtTelefono2',";
            $sql  .="	$cmbHoraEnSemana,$cmbHoraEnSabado,'$txtDireccionEntrega',";
            $sql  .="	$cmbZona,'$txtContactoEntrega','$txtDemora',";
            $sql  .="	$subtotal,'$Tarjeta',$recargoEnvio,$recargoArmado,";
            $sql  .="	$recargoEscalera,$total,'$comentarios','$mail_cliente','$aliasml',$cmbEmpresa)";
 
 
        
            
            
            mysqli_query( $conn,$sql);
            $actualizados=mysqli_affected_rows($conn);
            
       	    $result["sql"] = $sql;
       	
         	$myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
            fwrite($myfile, "\n");  
                 	
     	    fwrite($myfile, date("Y-m-d H:i:s")."*****************ALTA*****************");
            fwrite($myfile, "\n");  
            fwrite($myfile, $sql);
            fclose($myfile);
    
            $sql  ="INSERT INTO `estados_de_contrato`(`contrato_id`, `fecha`, `usuario_id`, `tipo_estado_id`, `observaciones`, `borrado`) VALUES ";
            $sql  .="   ($id,now(),$usuario_id,1,'Creado',0)";
            @mysqli_query( $conn,$sql);

         	$myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
            fwrite($myfile, "\n");  
                 	
     	    fwrite($myfile, date("Y-m-d H:i:s")."*****************ALTA*****************");
            fwrite($myfile, "\n");  
            fwrite($myfile, $sql);
            fclose($myfile);
    
            //si vienen armo un arreglo con el contenido y doy de alta

            if (isset($_POST['renglones'])){
                $renglones= json_decode($_POST['renglones'], true);
                
                $sql = "delete from  contrato_detalle_adicionales where contrato_id=$id";
                @mysqli_query( $conn,$sql);
                $sql = "delete from  contratos_detalle where contrato_id=$id";
                @mysqli_query( $conn,$sql);

                $orden=0;
                 foreach($renglones as $cr){
                     //primero meto los renglones de los productos 
                    $orden++;
                    if (empty($cr[_parentId])) {
					    list($renglon_id, $producto_id) = explode(".", $cr[id]);
                        //busco la fabrica del producto que se esta insertando
                        $sql= " select fabrica_id from productos_por_fabrica where  producto_id=$producto_id ";
                        $rs = mysqli_query( $conn,$sql);
                        $row = mysqli_fetch_row($rs);
                        $fabrica_id = $row[0];
                        
                        if ($Tarjeta=='on'){
                            $precio_producto=  $cr[precio_tarjeta];
                        }
                        else
                        {
                            $precio_producto= $cr[preciounitario];
                        }
                           
    					
                        $sql  ="INSERT INTO `contratos_detalle`";
                        $sql  .="(`contrato_id`, `renglon_id`, `producto_id`, ";
                        $sql  .="`fabrica_id`, `fecha_fin`, `precio`,";
                        $sql  .="`borrado`) VALUES ";
                        $sql  .="($id,$renglon_id,$producto_id,";
                        $sql  .="$fabrica_id,now(),$precio_producto,";
                        $sql  .="0)"; 
					    @mysqli_query( $conn,$sql);
                        //guardo en log el sql realizado para el producto
               		    $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
              		    fwrite($myfile, "\n");
        
                	    fwrite($myfile, $sql);
        		        fwrite($myfile, "\n");        	    
                	    fclose($myfile);					    

					} 

                }
                 foreach($renglones as $cr){
                    $orden++;
                    if (!empty($cr[_parentId]))  
                    {
                        //luego que todos los renglones de los productos estan metidos meto los adicionales
						list($renglon_id, $producto_id, $adicional_id) = explode(".", $cr[id]);
    
                        $sql= " select fabrica_id from productos_por_fabrica where  producto_id=$producto_id ";
                        $rs = mysqli_query( $conn,$sql);
                        $row = mysqli_fetch_row($rs);
                        $fabrica_id = $row[0];
                           
    					
                        $sql  ="INSERT INTO `contrato_detalle_adicionales`";
                        $sql  .="(`contrato_id`, `renglon_id`, `producto_id`, ";
                        $sql  .="`adicional_id`, `precio`,  ";
                        $sql  .="`borrado`) VALUES ";
                        $sql  .="($id,$renglon_id,$producto_id,";
                        $sql  .="$adicional_id,$cr[preciounitario],";
                        $sql  .="0)"; 
	                    @mysqli_query( $conn,$sql);

						//guardo en log el sql realizado para el detalle
 
				        $myfile = fopen("logFile.txt", "a") or die("Unable to open file!");
              		    fwrite($myfile, "\n");
                	    fwrite($myfile, $sql);
        		        fwrite($myfile, "\n");        	    
                	    fclose($myfile);		 
						 
					}
                }          


            } //fin de area de manejo de renglones
      
    }// fin alta 
    
    mysqli_query( $conn,"COMMIT");
                    $result["actualizados"]=$actualizados;
                    if ($actualizados>0) {
                    $result["estado"]=true;
                    $result["msg"] = "Contrato actualizado. ";
                    } else
                    {
                    $result["estado"]=false;
                    $result["msg"] = "No se realizo Ninguna actualizacion en la base de datos.";
                        
                    }
    
    echo json_encode($result);
	
} catch(exception $error) {
    
mysqli_query( $conn,"ROLLBACK");
$result["msg"] = "Errores grabando en la base de datos: ".$error->getMessage();
$result["estado"]=false;

echo json_encode($result);
	
}
    
  
?>